$:.unshift File.expand_path("../../lib", __FILE__)
$:.unshift File.expand_path("../../test", __FILE__)

require "thrift_client"
require 'thrift'
require 'foobar/common_service'
require 'foobar/foo_service'
require 'foobar/bar_service'
require 'foobar/handler'

module Test
  module Helper
    include Thrift

    def self.start_server(host = "127.0.0.1", port = 9000)
      common_handler = Test::CommonHandler.new
      common_processor = Test::CommonService::Processor.new(common_handler)
      foo_handler = Test::FooHandler.new
      foo_processor = Test::FooService::Processor.new(foo_handler)
      bar_handler = Test::BarHandler.new
      bar_processor = Test::BarService::Processor.new(bar_handler)
      processor = Thrift::MultiplexedProcessor.new
      processor.register(common_processor.class.name.split("::")[-2].downcase.gsub("service",""), common_processor)
      processor.register(foo_processor.class.name.split("::")[-2].downcase.gsub("service",""), foo_processor)
      processor.register(bar_processor.class.name.split("::")[-2].downcase.gsub("service",""), bar_processor)
      transport = Thrift::ServerSocket.new(host, port)
      transport_factory = Thrift::FramedTransportFactory.new
      protocol_factory = Thrift::CompactProtocolFactory.new
      args = [processor, transport, transport_factory, protocol_factory]
      server = Thrift::NonblockingServer.new(*args)
      @server = server
      sleep(1)
      @server_thread = Thread.new do
        @server.serve
      end
      sleep(1)
      puts "server start listen on #{host}:#{port}"
    end

    def self.shutdown_server
      return if @server.nil?
      if @server.respond_to? :shutdown
        @server.shutdown
      else
        @server_thread.kill
      end
    end

  end
end
