$:.unshift File.expand_path("../../lib", __FILE__)
$:.unshift File.expand_path("../../test", __FILE__)

require "test/unit"
require "thrift_client"
require "thrift"


DISCONNECT_ERRORS = [
    IOError,
    Thrift::ProtocolException,
    Thrift::TransportException
  ]
APPLICATION_ERRORS =[
    Thrift::ApplicationException
  ]
DEFAULTS = {
    :protocol => Thrift::CompactProtocol,
    :transport => Thrift::Socket,
    :transport_wrapper => Thrift::FramedTransport,
    :disconnect_exception_classes => nil,
    :application_exception_classes => nil,
    :size => 1,
    :timeout => nil,
    :client_class => nil,
    :test_on_borrow => true,
    :pool_timeout => 5,
    :before_method => [],
    :after_method => [],
    :on_exception => []
  }
config = {
    "protocol" => "Thrift::CompactProtocol",
    "transport" => "Thrift::Socket",
    "transport_wrapper" => "Thrift::FramedTransport",
    "disconnect_exception_classes" => "NameError,ArgumentError,StandardError,IOError",
    "application_exception_classes" => "IOError,,",
    "size" => nil,
    "timeout" => nil,
    "client_class" => nil,
    "test_on_borrow" => "true",
    "pool_timeout" => "5",
    "before_method" => [],
    "after_method" => [],
    "on_exception" => []
  }

user_options = {}
user_options.store(:protocol,eval(config["protocol"]))
user_options.store(:transport,eval(config["transport"]))
user_options.store(:transport_wrapper,eval(config["transport_wrapper"]))

user_define_disconnect_exceptions = config["disconnect_exception_classes"].split(",")
# puts user_define_exceptions
user_define_disconnect_exceptions.each do |exception|
    DISCONNECT_ERRORS.push(eval(exception))
end
DISCONNECT_ERRORS.uniq!
DISCONNECT_ERRORS.each do |error|
    # puts error.class
    # puts error
end
user_options.store(:disconnect_exception_classes, DISCONNECT_ERRORS)

user_define_application_exceptions = config["application_exception_classes"].split(",")
puts user_define_application_exceptions
user_define_application_exceptions.each do |exception|
    # puts exception
    APPLICATION_ERRORS.push(eval(exception))
end
APPLICATION_ERRORS.uniq!
APPLICATION_ERRORS.each do |error|
    # puts error.class
    # puts error
end
user_options.store(:application_exception_classes, APPLICATION_ERRORS)

if config["size"] != nil
    user_options.store(:size, config["size"].to_i)
end

servers = "192.168.3.111:8888,192.168.2.111:8888".split(",")
servers.each do |server|
    puts server
    puts server.class
end