$:.unshift File.expand_path("../../lib", __FILE__)
$:.unshift File.expand_path("../../test", __FILE__)

require "test/unit"
require "thrift_client"
require "foobar/common_service"

class ClientTest < Test::Unit::TestCase
  include Test::Unit::Assertions

  def setup
    super
    @config = {
      "protocol" => "binary",
      "transport" => "socket",
      "framed" => false,
      "disconnect_exception_classes" => nil,
      "application_exception_classes" => nil,
      "size" => 1,
      "timeout" => 10,
      "multiplexed" => false,
      "client_class" => nil,
      "servers" => ""
    }
    puts "\nsetup"
  end

  def test_config
    assert_raise ArgumentError do
      client = ThriftClient.new(@config)
    end
    @config["client_class"] = "231"
    assert_raise ArgumentError do
      client = ThriftClient.new(@config)
    end
    @config["client_class"] = "Test::CommonService::"
    assert_raise ArgumentError do
      client = ThriftClient.new(@config)
    end
    @config["client_class"] = "Test::CommonService::Client"
    assert_raise ArgumentError do
      client = ThriftClient.new(@config)
    end
    @config["servers"] = "127.0.0.1:9000"
    assert_nothing_raised ArgumentError do
      client = ThriftClient.new(@config)
    end
  end

  def teardown
    super
    puts "teardown"
  end
end